#include <stm32l4xx.h>                 // part of STM32Cube_FW_L4 package

void SystemInit(void)                  // set MCU system clock, executed before main()
{
  #if (__FPU_PRESENT==1) && (__FPU_USED==1) // FPU settings
    SCB->CPACR|=((3UL<<10*2)|(3UL<<11*2));  // set CP10 and CP11 Full Access
  #endif
  SCB->VTOR=FLASH_BASE;                // vector table relocation in internal FLASH, (use SRAM_BASE for SRAM), IVT must be 512B aligned!
  RCC->CIER=0x00000000;                // disable all interrupts
  // Set the RCC clock configuration HSI 16MHz
  RCC->CR|=RCC_CR_HSION;               // enable HSI [RCC_CR_MSION|RCC_CR_HSION|RCC_CR_HSEON|RCC_CR_PLLON]
  while (!(RCC->CR&RCC_CR_HSIRDY_Msk)) { __asm__ ("nop"); } // wait until HSI is ready
  RCC->CFGR=RCC_CFGR_SW_HSI;           // set system clock to HSI [RCC_CFGR_SW_MSI|RCC_CFGR_SW_HSI|RCC_CFGR_SW_HSE|RCC_CFGR_SW_PLL]
  RCC->CR&=~(RCC_CR_MSION|RCC_CR_HSEON|RCC_CR_PLLON|RCC_CR_CSSON); // disable other oscillators and disable Clock Security System
  // Set the RCC clock configuration HSE 8MHz
/*
  RCC->CR|=RCC_CR_HSEON;               // enable HSE [RCC_CR_MSION|RCC_CR_HSION|RCC_CR_HSEON|RCC_CR_PLLON]
  while (!(RCC->CR&RCC_CR_HSERDY_Msk)) { __asm__ ("nop"); } // wait until HSE is ready
  RCC->CFGR=RCC_CFGR_SW_HSE;           // set system clock to HSE [RCC_CFGR_SW_MSI|RCC_CFGR_SW_HSI|RCC_CFGR_SW_HSE|RCC_CFGR_SW_PLL]
  RCC->CR&=~(RCC_CR_MSION|RCC_CR_HSION|RCC_CR_PLLON|RCC_CR_CSSON); // disable other oscillators and disable Clock Security System
*/
  RCC->PLLCFGR=RCC_PLLCFGR_PLLN_4;     // reset PLLCFGR register
  RCC->CR&=~RCC_CR_HSEBYP;             // reset HSE clock bypass
}
